

#ifndef __FL_COMMON_H__
#define __FL_COMMON_H__


// NOTE: OS header


#include "fl_conf_id.h"


/******************************************************************************
 * Data type definitions (for portability)
 ******************************************************************************/

typedef unsigned char fl_uint8_t;
typedef signed char fl_int8_t;
typedef unsigned short fl_uint16_t;
typedef signed short fl_int16_t;
typedef unsigned int fl_uint32_t;
typedef signed int fl_int32_t;
typedef unsigned long long fl_uint64_t;
typedef signed long long fl_int64_t;
typedef unsigned long fl_uint3264_t;
typedef signed long fl_int3264_t;


/**************************** Public definitions ******************************/


struct fl_ret_s
{
	fl_int32_t *var;
	fl_uint32_t value;
	fl_uint32_t use_value;
	fl_uint32_t reset;
};


struct fl_args_s
{
	struct fl_ret_s ret;
};


fl_uint32_t fl_loop_forever = 1;


#define FL_LOOP_FOREVER (fl_loop_forever == 1)


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#define FL_UPRINTF(ARG) uprintf ## ARG;


#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


#define FL_UPRINTF(ARG) printf ## ARG;
#define FL_PRINTF(ARG) printf ## ARG;


// NOTE: ESUCCESS
//
//  ESUCCESS is a macro defined in Tru64 V5.1B-3+
//  that indicates success (or absence of error)
//  and is defined in that OS's sys/errno.h header.


#define ESUCCESS 0


#               endif
#       endif
#endif


/**************************** Debug definitions *******************************/

#ifdef FL_DEBUG


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#define FL_DEBUG_UPRINTF(ARG) uprintf ## ARG;
#define FL_DEBUG_PRINTF(ARG) printf ## ARG;


#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


/* TEMP: Console debugging
#define FL_DEBUG_UPRINTF(ARG) printf ## ARG;
#define FL_DEBUG_PRINTF(ARG) printf ## ARG;
*/


// Forward declaration
int fl_kelog_printf(fl_uint32_t,
                    char *,
                    ...);


#define FL_DEBUG_UPRINTF(ARG) sync_printf ## ARG;
#define FL_DEBUG_PRINTF(ARG) sync_printf ## ARG;


//#define FL_DEBUG_UPRINTF(ARG) printf ## ARG;
//#define FL_DEBUG_PRINTF(ARG) printf ## ARG;


//#define FL_DEBUG_UPRINTF(ARG) fl_kelog_printf ## ARG;
//#define FL_DEBUG_PRINTF(ARG)  fl_kelog_printf ## ARG;


#               endif
#       endif
#endif


#else


#define FL_DEBUG_UPRINTF(ARG)
#define FL_DEBUG_PRINTF(ARG)


#endif  // FL_DEBUG


#endif  // __FL_COMMON_H__


