

#ifndef __FL_MEM_H__
#define __FL_MEM_H__


// NOTE: OS header


#include "fl_conf_id.h"


// NOTE: System header files


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


#               endif
#       endif
#endif


// NOTE: Local header files


#include "fl_common.h"


// NOTE: Macro definitions


#define FL_MEM_NULL 0
#define FL_MEM_ZERO 1
#define FL_MEM_WAITOK 2
#define FL_MEM_NOWAIT 4
#define FL_MEM_CACHEALIGN 8


#define FL_MEM_TRACK


struct mem_track_s
{
        void *data;
        char *function; 
        char *purpose;
        fl_uint64_t size;
};      


int fl_mem_init(void);
int fl_mem_deinit(void);
int fl_mem_lock(void);
int fl_mem_unlock(void);
int fl_mem_alloc(void **,
                 fl_uint3264_t,
                 fl_uint32_t,
                 char *,
                 char *);
int fl_mem_alloc_notrack(void **, 
                         fl_uint3264_t, 
                         fl_uint32_t);
int fl_mem_free(void *);
int fl_mem_free_notrack(void *);
int fl_mem_dump(void);


#endif	// __FL_MEM_H__


