

// NOTE: System header files


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


#               endif
#       endif
#endif


// NOTE: Local header files


#include "fl_print.h"


// NOTE: Extern definitions


extern struct fl_spin_s *loop_list_lock;


int fl_print_vnode(struct vnode *vp)    // -- IN
{
        // NOTE: Arguments


        // IN: Check for vnode
        if (vp == NULL)
        {
                return 0;       // ERROR: No vnode
        }


        // NOTE: Processing


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


//typedef struct vnode {
//        struct vnlist   v_list;                 // freelist linkage //
//        uint            v_flag;                 // vnode flags (see below) //
//        int             v_count;                // reference count //
//        short           v_listid;               // free list id //
//        uchar_t         v_reserved1;            // reserved for future use //
//        uchar_t         v_reserved2;            // reserved for future use //
//        int             v_intpcount;            // interp. refcount for imon //
//        enum vtype      v_type;                 // vnode type //
//        dev_t           v_rdev;                 // device (VCHR, VBLK) //
//        struct vfs      *v_vfsmountedhere;      // ptr to vfs mounted here //
//        struct vfs      *v_vfsp;                // ptr to containing VFS //
//        struct stdata   *v_stream;              // associated stream //
//        struct filock   *v_filocks;             // ptr to filock list //
//        mutex_t         v_filocksem;            // mutex for list //
//        vnumber_t       v_number;               // in-core vnode number //
//        vn_bhv_head_t   v_bh;                   // behavior head //
//
//        uint64_t        v_namecap;              // name cache capability //
//
//        //
//         * Used only by global cache.
//         //
//        struct vnode    *v_hashp;               // hash list for lookup //
//        struct vnode    *v_hashn;               // hash list for lookup //
//
//        //
//         * Values manipulated only by VM and
//         * the page/buffer caches.  Note that v_traceix, which
//         * has been shoehorned in here to use otherwise-unused space
//         * is an exception.
//         //
//        struct pregion  *v_mreg;                // mapped file region pointer //
//        struct pregion  *v_mregb;               // mapped file region pointer //
//        pgno_t          v_pgcnt;                // pages hashed to vnode //
//        struct pfdat    *v_dpages;              // delwri pages //
//        unsigned int    v_dpages_gen;           // delwri pages generation no //
//        int             v_dbuf;                 // delwri buffer count //
//        struct buf      *v_buf;                 // vnode buffer tree head //
//        unsigned int    v_bufgen;               // buf list generation number //
//        unsigned int    v_traceix;              // trace table index //
//        mutex_t         v_buf_lock;             // mutex for buffer tree //
//
//        vnode_pcache_t  v_pc;                   // Page cache structure.
//                                                // per vnode. Refer to
//                                                // vnode_pcache.h
//                                                // for details.
//                                                //
//#ifdef VNODE_TRACING
//        struct ktrace   *v_trace;               // trace header structure    //
//#endif // VNODE_TRACING //
//#ifdef CKPT
//        ckpt_handle_t   v_ckpt;                 // ckpt lookup info //
//#endif
//} vnode_t;


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_list = %p\n",
                    &vp->v_list))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_flag = %lu\n",
                    vp->v_flag))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_count = %lu\n",
                    vp->v_count))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_listid = %lu\n",
                    vp->v_listid))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_reserved1 = %d\n",
                    vp->v_reserved1))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_reserved2 = %d\n",
                    vp->v_reserved2))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_intpcount = %d\n",
                    vp->v_intpcount))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_type = %d\n",
                    vp->v_type))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_rdev = %lu\n",
                    vp->v_rdev))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_vfsmountedhere = %p\n",
                    vp->v_vfsmountedhere))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_vfsp = %p\n",
                    vp->v_vfsp))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_stream = %p\n",
                    vp->v_stream))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_filocks = %p\n",
                    vp->v_filocks))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_filocksem = %p\n",
                    vp->v_filocksem))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_number = %p\n",
                    vp->v_number))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_bh = %p\n",
                    &vp->v_bh))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_namecap = %lu\n",
                    vp->v_namecap))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_hashp = %p\n",
                    vp->v_hashp))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_hashn = %p\n",
                    vp->v_hashn))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_mreg = %p\n",
                    vp->v_mreg))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_mregb = %p\n",
                    vp->v_mregb))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_pgcnt = %p\n",
                    &vp->v_pgcnt))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_dpages = %p\n",
                    vp->v_dpages))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_dpages_gen = %lu\n",
                    vp->v_dpages_gen))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_dbuf = %d\n",
                    vp->v_dbuf))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_buf = %p\n",
                    vp->v_buf))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_bufgen = %lu\n",
                    vp->v_bufgen))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_traceix = %lu\n",
                    vp->v_traceix))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_buf_lock = %p\n",
                    vp->v_buf_lock))


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_pc = %p\n",
                    &vp->v_pc))


#ifdef VNODE_TRACING


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_trace = %p\n",
                    vp->v_trace))


#endif


#ifdef CKPT


        FL_UPRINTF((\
                    "[fl_print_vnode] INFO: v_ckpt = %p\n",
                    &vp->v_ckpt))


#endif


#               endif
#       endif
#endif


        return 1;       // SUCCESS
}


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#               endif
#       endif
#endif


int fl_print_loop(fl_list_t *loop_list) // -- IN
{
        fl_uint64_t list_index;
        fl_uint64_t list_length;
        fl_list_node_t *list_node;
        struct loop_entry_s *loop_entry;


        // NOTE: Arguments


        // IN: Check for loop list
        if (loop_list == NULL)
        {
                return 0;       // ERROR: No loop list
        }


        // NOTE: Processing


        // Acquire lock for loop list
        fl_spin_lock(loop_list_lock);


        // Get length of loop list
        fl_list_length(loop_list,
                       &list_length);


        // Traverse loop list
        for (list_index = 0;
             list_index < list_length;
             list_index++)
        {
                // Get next list node
                fl_list_get_node(loop_list,
                                 &list_node,
                                 list_index);


                // Get loop entry
                loop_entry = (struct loop_entry_s *) list_node->data;


                // NOTE: Print loop entry


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu Device name = %s\n",
                            list_index,
                            loop_entry->dev.name))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu Device vnode = %p\n",
                            list_index,
                            loop_entry->dev.vp))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu Vnode refcount = %llu\n",
                            list_index,
                            loop_entry->dev.refcount))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu Device is_open = %d\n",
                            list_index,
                            loop_entry->dev.is_open))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu Device is_created = %d\n",
                            list_index,
                            loop_entry->dev.is_created))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu File name = %s\n",
                            list_index,
                            loop_entry->file.name))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu File vnode = %p\n",
                            list_index,
                            loop_entry->file.vp))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu Vnode refcount = %llu\n",
                            list_index,
                            loop_entry->file.refcount))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu File is_open = %d\n",
                            list_index,
                            loop_entry->file.is_open))


                FL_UPRINTF((\
                            "[fl_print_loop] INFO: %llu File is_created = %d\n",
                            list_index,
                            loop_entry->file.is_created))


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#               endif
#       endif
#endif

        }


        // Release lock for loop list
        fl_spin_unlock(loop_list_lock);


        return 1;       // SUCCESS
}


int fl_print_uio(struct uio *uio)       // -- IN
{
        fl_uint32_t iovcnt;


        // NOTE: Arguments


        // IN: Check for uio
        if (uio == NULL)
        {
                return 0;       // ERROR: No uio
        }


        // NOTE: Processing


//struct pm;
//struct vfile;
//
//typedef struct uio {
//        iovec_t         *uio_iov;       // pointer to array of iovecs //
//        int             uio_iovcnt;     // number of iovecs //
//        int             uio_fmode;      // file mode flags //
//        off_t           uio_offset;     // file offset //
//        short           uio_segflg;     // address space (kernel or user) //
//        short           uio_pio;        // parallel IO //
//        short           uio_sigpipe;    // send sigpipe before syscall retn //
//        uchar_t         uio_readiolog;  // preferred read size (log 2) //
//        uchar_t         uio_writeiolog; // preferred write size (log 2) //
//        ssize_t         uio_resid;      // residual count //
//        off_t           uio_limit;      // u-limit (maximum byte offset) //
//        struct pm       *uio_pmp;       // Policy Module pointer of NUMA //
//        struct buf      *uio_pbuf;      // buffer allocated by physio //
//        struct vfile    *uio_fp;        // file pointer //
//} uio_t;


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_iov = %p\n",
                    uio->uio_iov))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_iovcnt = %d 0x%x\n",
                    uio->uio_iovcnt,
                    uio->uio_iovcnt))


        if (uio->uio_iovcnt > 0)
        {
                for (iovcnt = 0;
                     iovcnt < uio->uio_iovcnt;
                     iovcnt++)
                {
                        FL_UPRINTF((\
                                    "[fl_print_uio] INFO: uio->uio_iov[%u].iov_base = %p 0x%8x\n",
                                    iovcnt,
                                    uio->uio_iov[iovcnt].iov_base,
                                    uio->uio_iov[iovcnt].iov_base))


                        FL_UPRINTF((\
                                    "[fl_print_uio] INFO: uio->uio_iov[%u].iov_len = %u 0x%x\n",
                                    iovcnt,
                                    uio->uio_iov[iovcnt].iov_len,
                                    uio->uio_iov[iovcnt].iov_len))
                }
        }


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_fmode = %d 0x%x\n",
                    uio->uio_fmode,
                    uio->uio_fmode))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_offset = %llu 0x%8x\n",
                    uio->uio_offset,
                    uio->uio_offset))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_segflg = %d 0x%x\n",
                    uio->uio_segflg,
                    uio->uio_segflg))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_segflgs = %d %d %d %d\n",
                    UIO_NOSPACE,
                    UIO_USERSPACE,
                    UIO_SYSSPACE,
                    UIO_USERISPACE))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_pio = %d 0x%x\n",
                    uio->uio_pio,
                    uio->uio_pio))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_sigpipe = %d 0x%x\n",
                    uio->uio_sigpipe,
                    uio->uio_sigpipe))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_readiolog = %u 0x%x\n",
                    uio->uio_readiolog,
                    uio->uio_readiolog))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_writeiolog = %u 0x%x\n",
                    uio->uio_writeiolog,
                    uio->uio_writeiolog))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_resid = %lld 0x%8x\n",
                    uio->uio_resid,
                    uio->uio_resid))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_limit = %llu 0x%8x\n",
                    uio->uio_limit,
                    uio->uio_limit))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_pmp = %p\n",
                    uio->uio_pmp))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_pbuf = %p\n",
                    uio->uio_pbuf))


        FL_UPRINTF((\
                    "[fl_print_uio] INFO: uio->uio_fp = %p\n",
                    uio->uio_fp))


        return 1;       // SUCCESS
}


int fl_print_buf(struct buf *buf)       // -- IN
{
        // NOTE: Arguments


        // IN: Check for buffer
        if (buf == NULL)
        {
                return 0;       // ERROR: No buffer
        }


        // NOTE: Processing


//typedef struct  buf {
//        //
//         / These first 4 fields must match the hbuf definition
//         / below.  DO NOT CHANGE THEM OR REARRANGE THEM.
//         //
//        sema_t  b_lock;                 // lock for buffer usage //
//        uint64_t b_flags;               // see defines below //
//        struct  buf *b_forw;            // headed by d_tab of conf.c //
//        struct  buf *b_back;            //  "  //
//        struct  buf *bd_forw;           // device based hash chain //
//        struct  buf *bd_back;           //  "  //
//        struct  dhbuf *bd_hash;         // hash bucket head //
//        struct  buf *av_forw;           // position on free list, //
//        struct  buf *av_back;           //     if not BUSY //
//        dev_t   b_edev;                 // major+minor device name //
//        int     b_error;                // returned after I/O //
//        off_t   b_offset;               // vnode offset (in basic blocks) //
//        buftarg_t *b_target;            // route to I/O device //
//        unsigned b_bcount;              // transfer count //
//        unsigned b_resid;               // words not transferred after error //
//        unsigned b_remain;              // virt b_bcount for PAGEIO use only //
//        unsigned b_bufsize;             // size in bytes of allocated buffer //
//        __psunsigned_t b_sort;          // key with which to sort on queue //
//        union {
//            caddr_t b_addr;             // low order core address //
//            int *b_words;               // words for clearing //
//            struct pfdat *b_pfdat;      // pointer into b_pages list //
//            daddr_t *b_daddr;           // disk blocks //
//        } b_un;
//        struct vnode *b_vp;             // object associated with bp //
//        daddr_t b_blkno;                // block # on device //
//        clock_t b_start;                // request start time //
//        struct  pfdat *b_pages;         // page list for PAGEIO //
//        void    *b_alenlist;            // address, length lists //
//        void (*b_relse)(struct buf *);  // function called by brelse //
//        sema_t  b_iodonesema;           // lock for waiting on I/O done //
//        void (*b_iodone)(struct buf *); // function called by iodone //
//        int (*b_bdstrat)(struct buf *); // function called by bwrite //
//        void    *b_private;             // for driver's use //
//        void    *b_fsprivate;           // private ptr for file systems //
//        void    *b_fsprivate2;          // private ptr for file systems //
//        void    *b_fsprivate3;          // private ptr for file systems //
//        short   b_pincount;             // count of times buf is pinned //
//        ushort  b_aflags;               // additional flags.  see below //
//        char    b_ref;                  // # of free trips through freelist //
//        char    b_balance;              // tree balance //
//        char    b_listid;               // free list number //
//        char    b_bvtype;               // bufview flags //
//        struct  buf *b_dforw;           // vnode delwri chain //
//        struct  buf *b_dback;           // vnode delwri chain //
//        struct  buf *b_parent;          // hash parent pointer //
//        union {
//                void    *b_gr_prv;      // private data for grio //
//                short   b_pri;          // io priority level //
//        } b_gr;
//        struct  buf *b_grio_list;       // list of bps used in grio //
//#ifdef DEBUG_BUFTRACE
//        struct ktrace   *b_trace;       // per buffer trace buffer //
//#endif
//#ifdef DEBUG_BUFTAGGING
//        bt_location_t   bt_loc[BT_RING_SIZE];   // ring buffer //
//        lock_t  bt_lock;                // ring buffer spinlock //
//        short   bt_head;                // head of ring buffer //
//#endif
//} buf_t;


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_lock = 0x%p\n",
                    buf->b_lock))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_flags = %llu = 0x%016x\n",
                    buf->b_flags,
                    buf->b_flags))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_forw = 0x%p\n",
                    buf->b_forw))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_back = 0x%p\n",
                    buf->b_back))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->bd_forw = 0x%p\n",
                    buf->bd_forw))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->bd_back = 0x%p\n",
                    buf->bd_back))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->bd_hash = 0x%p\n",
                    buf->bd_hash))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->av_forw = 0x%p\n",
                    buf->av_forw))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->av_back = 0x%p\n",
                    buf->av_back))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_edev = %llu %8x\n",
                    buf->b_edev))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_error = %d\n",
                    buf->b_error))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_offset = %llu %8x\n",
                    buf->b_offset))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_target = 0x%p\n",
                    buf->b_target))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_bcount = %u\n",
                    buf->b_bcount))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_resid = %u\n",
                    buf->b_resid))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_remain = %u\n",
                    buf->b_remain))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_bufsize = %u\n",
                    buf->b_bufsize))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_sort = %u\n",
                    buf->b_sort))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_un.b_addr = 0x%p\n",
                    buf->b_un.b_addr))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_un.b_words = 0x%p\n",
                    buf->b_un.b_words))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_un.b_pfdat = 0x%p\n",
                    buf->b_un.b_pfdat))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_un.b_daddr = 0x%p\n",
                    buf->b_un.b_daddr))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_vp = 0x%p\n",
                    buf->b_vp))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_blkno = 0x%p\n",
                    buf->b_blkno))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_start = %llu\n",
                    buf->b_start))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_pages = 0x%p\n",
                    buf->b_pages))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_alenlist = 0x%p\n",
                    buf->b_alenlist))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_relse = 0x%p\n",
                    buf->b_relse))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_iodonesema = 0x%p\n",
                    &buf->b_iodonesema))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_iodone = 0x%p\n",
                    buf->b_iodone))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_bdstrat = 0x%p\n",
                    buf->b_bdstrat))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_private = 0x%p\n",
                    buf->b_private))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_fsprivate = 0x%p\n",
                    buf->b_fsprivate))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_fsprivate2 = 0x%p\n",
                    buf->b_fsprivate2))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_fsprivate3 = 0x%p\n",
                    buf->b_fsprivate3))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_pincount = %d\n",
                    buf->b_pincount))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_aflags = %u\n",
                    buf->b_aflags))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_ref = %u\n",
                    buf->b_ref))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_balance = %u\n",
                    buf->b_balance))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_listid = %u\n",
                    buf->b_listid))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_bvtype = %u\n",
                    buf->b_bvtype))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_dforw = 0x%p\n",
                    buf->b_dforw))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_dback = 0x%p\n",
                    buf->b_dback))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_parent = 0x%p\n",
                    buf->b_parent))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_gr.b_gr_prv = 0x%p\n",
                    buf->b_gr.b_gr_prv))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_gr.b_pri = %d\n",
                    buf->b_gr.b_pri))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_grio_list = 0x%p\n",
                    buf->b_grio_list))


#ifdef DEBUG_BUFTRACE


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->b_trace = 0x%p\n",
                    buf->b_trace))


#endif


#ifdef DEBUG_BUFTAGGING


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->bt_loc = 0x%p\n",
                    buf->bt_loc))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->bt_lock = 0x%p\n",
                    &buf->bt_lock))


        FL_UPRINTF((\
                    "[fl_print_buf] INFO: buf->bt_head = %d\n",
                    buf->bt_head))


#endif


        return 1;       // SUCCESS
}


int fl_print_ioreq(struct fld_io_req_s *io_req) // -- IN
{
        fl_uint32_t control_index;
        char *fld_io_strings[] =
        {
                "FLD_IO_NULL",
                "FLD_IO_READ",
                "FLD_IO_READ_OK",
                "FLD_IO_READ_INCMPL",
                "FLD_IO_READ_EOF",
                "FLD_IO_READ_NOK",
                "FLD_IO_WRITE",
                "FLD_IO_WRITE_OK",
                "FLD_IO_WRITE_INCMPL",
                "FLD_IO_WRITE_EOF",
                "FLD_IO_WRITE_NOK",
                "FLD_IO_ERROR"
        };


        // NOTE: Arguments


        // IN: Check for I/O request
        if (io_req == NULL)
        {
                return 0; // ERROR: No I/O request
        }


        // NOTE: Processing


        // Get control field string
        control_index = 0;
        switch (io_req->control)
        {
                case FLD_IO_NULL:

                        control_index = 0;


                        break;

                case FLD_IO_READ:

                        control_index = 1;


                        break;

                case FLD_IO_READ_OK:

                        control_index = 2;


                        break;

                case FLD_IO_READ_INCMPL:

                        control_index = 3;


                        break;

                case FLD_IO_READ_EOF:

                        control_index = 4;


                        break;

                case FLD_IO_READ_NOK:

                        control_index = 5;


                        break;

                case FLD_IO_WRITE:

                        control_index = 6;


                        break;

                case FLD_IO_WRITE_OK:

                        control_index = 7;


                        break;

                case FLD_IO_WRITE_INCMPL:

                        control_index = 8;


                        break;

                case FLD_IO_WRITE_EOF:

                        control_index = 9;


                        break;

                case FLD_IO_WRITE_NOK:

                        control_index = 10;


                        break;

                default:

                        control_index = 11;


                        break;
        }


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: control = %s\n",
                    fld_io_strings[control_index]))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: offset = %llu (bytes)\n",
                    io_req->offset))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: size = %llu (bytes)\n",
                    io_req->size))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: dev = %u\n",
                    io_req->dev))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: |\n"))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: +- major = %u\n",
                    getemajor(io_req->dev)))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO:  |\n"))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO:  +- minor = %u\n",
                    geteminor(io_req->dev)))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: file = \"%s\"\n",
                    io_req->file))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: data = 0x%p\n",
                    io_req->data))


        FL_UPRINTF((\
                    "[fl_print_ioreq] INFO: data_size = %llu\n",
                    io_req->data_size))


        return 1;       // SUCCESS
}


int fl_print_vh(struct volume_header *vh)       // -- IN
{
        char *vd_name;
        char *pt_types[] = {

                "PTYPE_VOLHDR",
                "NOT_SUPPORTED",
                "NOT_SUPPORTED",
                "PTYPE_RAW",
                "NOT_SUPPORTED",
                "NOT_SUPPORTED",
                "PTYPE_VOLUME",
                "PTYPE_EFS",
                "PTYPE_LVOL",
                "PTYPE_RLVOL",
                "PTYPE_XFS",
                "PTYPE_XFSLOG",
                "PTYPE_XLV",
                "PTYPE_NONE"
        };
        fl_uint32_t vd_index;
        fl_uint32_t vd_lbn;
        fl_uint32_t vd_nbytes;
        fl_uint32_t vp_index;
        fl_uint32_t pt_nblks;
        fl_uint32_t pt_firstlbn;
        fl_uint32_t pt_type;


        // NOTE: Arguments


        // IN: Check for volume header
        if (vh == NULL)
        {
                return 0;       // ERROR: No volume header
        }


        // NOTE: Processing


        // Dump volume header
        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_magic = 0x%08x\n",
                    vh->vh_magic))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_rootpt = %u\n",
                    vh->vh_rootpt))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_swappt = %u\n",
                    vh->vh_swappt))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_bootfile = %s\n",
                    vh->vh_bootfile))


        // NOTE: Drive parameters


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_unused1 = 0x%08x\n",
                    vh->vh_dp.dp_unused1))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp._dp_cylinders = %u\n",
                    vh->vh_dp._dp_cylinders))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_unused2 = 0x%04x\n",
                    vh->vh_dp.dp_unused2))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp._dp_heads = 0x%04x\n",
                    vh->vh_dp._dp_heads))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_ctq_depth = 0x%02x\n",
                    vh->vh_dp.dp_ctq_depth))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_unused3 = 0x%06x\n",
                    vh->vh_dp.dp_unused3))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp._dp_sect = %u\n",
                    vh->vh_dp._dp_sect))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_secbytes = %u\n",
                    vh->vh_dp.dp_secbytes))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_unused4 = 0x%04x\n",
                    vh->vh_dp.dp_unused4))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_flags = %d\n",
                    vh->vh_dp.dp_flags))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_unused5 = 0x%040x\n",
                    vh->vh_dp.dp_unused5))


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh_dp.dp_drivecap = %u\n",
                    vh->vh_dp.dp_drivecap))


        // NOTE: Volume directory


        for (vd_index = 0;
             vd_index < NVDIR;
             vd_index++)
        {
                vd_name = vh->vh_vd[vd_index].vd_name;
                vd_lbn = vh->vh_vd[vd_index].vd_lbn;
                vd_nbytes = vh->vh_vd[vd_index].vd_nbytes;


                FL_UPRINTF((\
                            "[fl_print_vh] INFO: vh_vd[%u].vd_name = %s\n",
                            vd_index, vd_name))


                FL_UPRINTF((\
                            "[fl_print_vh] INFO: vh_vd[%u].vd_lbn = %d\n",
                            vd_index, vd_lbn))


                FL_UPRINTF((\
                            "[fl_print_vh] INFO: vh_vd[%u].vd_nbytes = %d\n",
                            vd_index, vd_nbytes))
        }


        // NOTE: Partition table


        for (vp_index = 0;
             vp_index < NPARTAB;
             vp_index++)
        {
                pt_nblks = vh->vh_pt[vp_index].pt_nblks;
                pt_firstlbn = vh->vh_pt[vp_index].pt_firstlbn;
                pt_type = vh->vh_pt[vp_index].pt_type;


                FL_UPRINTF((\
                            "[fl_print_vh] INFO: vh_pt[%u].pt_nblks = %d\n",
                            vp_index,
                            pt_nblks))


                FL_UPRINTF((\
                            "[fl_print_vh] INFO: vh_pt[%u].pt_firstlbn = %d\n",
                            vp_index,
                            pt_firstlbn))


                FL_UPRINTF((\
                            "[fl_print_vh] INFO: vh_pt[%u].pt_type = %d (%s)\n",
                            vp_index,
                            pt_type,
                            pt_types[pt_nblks > 0 ? pt_type : 13]))
        }


        // NOTE: Checksum field


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh->vh_csum = %d\n",
                    vh->vh_csum))


        // NOTE: Filler field


        FL_UPRINTF((\
                    "[fl_print_vh] INFO: vh->vh_fill = 0x%08x\n",
                    vh->vh_fill))


        return 1;       // SUCCESS
}


int fl_print_data(char *data,                   // -- IN
                  fl_uint32_t data_size,        // -- IN
                  fl_uint32_t bytes_per_row)    // -- IN
{
        char print_buffer[1024];
        fl_uint32_t data_index;
        fl_uint32_t buffer_index;
        fl_uint32_t halves_index;
        fl_uint32_t byte_halve;


        // NOTE: Arguments


        // IN: Check for data
        if (data == NULL)
        {
                return 0;       // ERROR: No data
        }


        // IN: Check for data size
        if (data_size == 0)
        {
                return 2;       // SUCCESS: Data size is zero
        }


        // IN: Check for bytes per row
        if (bytes_per_row == 0)
        {
                return -1;      // ERROR: Bytes per row is zero
        }


        // NOTE: Processing


        // Create print buffer
        buffer_index = 0;
        for (data_index = 0;
             data_index < data_size;
             data_index++)
        {
                // Convert to ASCII character
                byte_halve = (data[data_index] & 0xf0) >> 4;
                for (halves_index = 0;
                     halves_index < 2;
                     halves_index++)
                {
                        if (byte_halve <= 9)
                        {
                                print_buffer[buffer_index] = (fl_uint8_t) '0' +
                                                             (fl_uint8_t) byte_halve;
                        }
                        else if ((byte_halve >= 'a') &&
                                 (byte_halve <= 'f'))
                        {
                                print_buffer[buffer_index] = (fl_uint8_t) 'a' +
                                                             ((fl_uint8_t) byte_halve -
                                                              (fl_uint8_t) 'a');
                        }


                        // Increment buffer index
                        buffer_index++;


                        // Get second byte halve
                        byte_halve = data[data_index] & 0x0f;
                }


                // Check for last character
                if ((data_index + 1) < data_size)
                {
                        // Check for row boundary
                        if (((data_index + 1) % bytes_per_row) == 0)
                        {
                                // Add terminating NULL byte
                                print_buffer[buffer_index] = '\0';


                                // Print row
                                printf("%s\n",
                                       print_buffer);


                                // Reset buffer index
                                buffer_index = 0;


                                continue;
                        }
                        else
                        {
                                // Add space
                                print_buffer[buffer_index] = ' ';
                        }
                }
                else
                {
                        // Add terminating NULL byte
                        print_buffer[buffer_index] = '\0';
                }


                // Increment buffer index
                buffer_index++;
        }


        // Print buffer
        FL_UPRINTF((\
		    "%s\n",
		    print_buffer))


        return 1;       // SUCCESS
}


int fl_print_packet(struct fl_packet_s *packet)	// -- IN
{
	// NOTE: Arguments


	// IN: Check for packet
	if (packet == NULL)
	{
		return 0;	// ERROR: No packet
	}


	// NOTE: Processing


	FL_DEBUG_UPRINTF(("[fl_print_packet] INFO: packet->dev = \"%s\"\n",
			  packet->dev))


	FL_DEBUG_UPRINTF(("[fl_print_packet] INFO: packet->file = \"%s\"\n",
			  packet->file))


	FL_DEBUG_UPRINTF(("[fl_print_packet] INFO: packet->data = %p\n",
			  packet->data))


	FL_DEBUG_UPRINTF(("[fl_print_packet] INFO: packet->dev_size = %u\n",
			  packet->dev_size))


	FL_DEBUG_UPRINTF(("[fl_print_packet] INFO: packet->file_size = %u\n",
			  packet->file_size))


	FL_DEBUG_UPRINTF(("[fl_print_packet] INFO: packet->cmd = %u\n",
			  packet->cmd))


	FL_DEBUG_UPRINTF(("[fl_print_packet] INFO: packet->size = %u\n",
			  packet->size))


	return 1;	// SUCCESS
}


