

#ifndef __FL_SEM_H__
#define __FL_SEM_H__


// NOTE: OS header


#include "fl_conf_id.h"


// NOTE: System header files


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


#include <sys/types.h>


#               endif
#       endif
#endif


// NOTE: Local header files


#include "fl_common.h"


// NOTE: Macro definitions


#define FL_SEM_SWITCH_NULL 0
#define FL_SEM_SWITCH_ENABLE_INTERRUPT 1
#define FL_SEM_SWITCH_RETURN_ON_SLEEP 2
#define FL_SEM_SWITCH_MASK 3


#define FL_SEM_INF_NULL 0
#define FL_SEM_INF_INCR 1
#define FL_SEM_INF_DECR 2


struct fl_sem_s
{
        fl_uint32_t inf;
        fl_uint64_t value;
 
 
#if FL_OS_NAME_V_OSF1 
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B
 
 
#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30
 
 
        lock_t *slock;
 
 
#               endif
#       endif
#endif
 
 
}; 
 
 
typedef struct fl_sem_s fl_sem_t;


////////////////////////
// NOTE: Declarations //
////////////////////////


// NOTE: Function prototypes


int fl_sem_init(fl_sem_t **,
		fl_uint64_t);
int fl_sem_deinit(fl_sem_t **);
int fl_sem_get_value(fl_sem_t *,
		     fl_uint64_t *);
int fl_sem_get_inf(fl_sem_t *,
		   fl_uint32_t *);


#if FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


void fl_sem_timer_callback(void *,
                           void *,
                           fl_uint32_t);


#               endif
#       endif
#endif


int fl_sem_incr(fl_sem_t *,
                fl_uint64_t,
                fl_uint32_t,
		struct fl_args_s *);
int fl_sem_incr_inf(fl_sem_t *);
int fl_sem_decr(fl_sem_t *,
                fl_uint64_t,
                fl_uint32_t,
		struct fl_args_s *);
int fl_sem_decr_inf(fl_sem_t *);


#endif	// __FL_SEM_H__


