

#ifndef __FL_SPIN_H__
#define __FL_SPIN_H__


// NOTE: OS header


#include "fl_conf_id.h"


// NOTE: System header files


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


#               endif
#       endif
#endif


// NOTE: Local header files


#include "fl_common.h"


#if defined(FL_SPIN_DEBUG)


// NOTE: Spin debug list
//
//  The global spin debug list holds an entry for
//  each allocated spin lock. Each entry has enough
//  fields to profile the whole activity of the
//  spin lock throughout its lifetime.
//
//  This information is used for debugging purposes.


struct fl_spin_debug_func_s
{
	// Number of error returns
	fl_uint64_t ret_errors;


	// Last return value
	fl_uint64_t ret_last;


	// Free without new
	fl_uint32_t free_without_new;


	// TODO: Double new


	// TODO: Double free
};


struct fl_spin_debug_s
{
	fl_uint32_t fl_spin_new;
	fl_uint32_t fl_spin_free;
	fl_uint32_t fl_spin_lock;
	fl_uint32_t fl_spin_unlock;
	fl_uint32_t fl_spin_trylock;
};


#endif	// defined(FL_SPIN_DEBUG)


struct fl_spin_s
{


#if FL_OS_NAME_V_OSF1 
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B
 
 
#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30
 
 
	lock_t *lock;
	fl_int32_t pl;


#if defined(FL_SPIN_DEBUG)


	struct fl_spin_debug_s debug;


#endif	// defined(FL_SPIN_DEBUG)
 
 
#               endif
#       endif
#endif
 
 
}; 
 
 
typedef struct fl_spin_s fl_spin_t;


int fl_spin_new(struct fl_spin_s **);
int fl_spin_free(struct fl_spin_s *);
int fl_spin_lock(struct fl_spin_s *);
int fl_spin_unlock(struct fl_spin_s *);
int fl_spin_trylock(struct fl_spin_s *,
		    fl_uint32_t *is_locked);


#endif	// __FL_SPIN_H__


