

#ifndef __FL_TEST_H__
#define __FL_TEST_H__


// FL_TEST is a marker for to-be-tested cases
#define FL_TEST(FUNC, NAME)


#ifdef FL_TESTS


#include "fl_conf_id.h"


#define FL_TEST_INIT() fl_test_init();
#define FL_TEST_DEINIT() fl_test_deinit();


#define FL_TEST_RET int fl_test_ret;


#define FL_TEST_COND(COND, OP) COND ## OP


#define FL_TEST_F_main_N_NOT_SUSER() fl_test_ret = fl_test_f_main_n_NOT_SUSER();
#define FL_TEST_F_main_N_ATTACH_EACCES_DEV() fl_test_ret = fl_test_f_main_n_ATTACH_EACCES_DEV();
#define FL_TEST_F_main_N_ATTACH_EIO_DEV() fl_test_ret = fl_test_f_main_n_ATTACH_EIO_DEV();
#define FL_TEST_F_main_N_ATTACH_ELOOP_DEV() fl_test_ret = fl_test_f_main_n_ATTACH_ELOOP_DEV();
#define FL_TEST_F_main_N_ATTACH_ENOMEM_DEV() fl_test_ret = fl_test_f_main_n_ATTACH_ENOMEM_DEV();
#define FL_TEST_F_main_N_ATTACH_ENOTDIR_DEV() fl_test_ret = fl_test_f_main_n_ATTACH_ENOTDIR_DEV();
#define FL_TEST_F_main_N_ATTACH_EACCES_FILE() fl_test_ret = fl_test_f_main_n_ATTACH_EACCES_FILE();
#define FL_TEST_F_main_N_ATTACH_EIO_FILE() fl_test_ret = fl_test_f_main_n_ATTACH_EIO_FILE();
#define FL_TEST_F_main_N_ATTACH_ELOOP_FILE() fl_test_ret = fl_test_f_main_n_ATTACH_ELOOP_FILE();
#define FL_TEST_F_main_N_ATTACH_ENOMEM_FILE() fl_test_ret = fl_test_f_main_n_ATTACH_ENOMEM_FILE();
#define FL_TEST_F_main_N_ATTACH_ENOTDIR_FILE() fl_test_ret = fl_test_f_main_n_ATTACH_ENOTDIR_FILE();
#define FL_TEST_F_main_N_DETACH_EACCES() fl_test_ret = fl_test_f_main_n_DETACH_EACCES();
#define FL_TEST_F_main_N_DETACH_EIO() fl_test_ret = fl_test_f_main_n_DETACH_EIO();
#define FL_TEST_F_main_N_DETACH_ELOOP() fl_test_ret = fl_test_f_main_n_DETACH_ELOOP();
#define FL_TEST_F_main_N_DETACH_ENOMEM() fl_test_ret = fl_test_f_main_n_DETACH_ENOMEM();
#define FL_TEST_F_main_N_DETACH_ENOTDIR() fl_test_ret = fl_test_f_main_n_DETACH_ENOTDIR();
#define FL_TEST_F_main_N_NOT_ALLOC_RESPONSE_PACKET() fl_test_ret = fl_test_f_main_n_NOT_ALLOC_RESPONSE_PACKET();
#define FL_TEST_F_main_N_NO_PERMISSION_PACKET_DATA() fl_test_ret = fl_test_f_main_n_NO_PERMISSION_PACKET_DATA();
#define FL_TEST_F_main_N_NOT_PARSE_RESPONSE_PACKET() fl_test_ret = fl_test_f_main_n_NOT_PARSE_RESPONSE_PACKET();


// NOTE: Platform specific test macros


#if FL_OS_NAME_V_OSF1
#       if FL_OS_VERSION_V_5_1
#               if FL_OS_RELEASE_V_B


#               endif
#       endif
#elif FL_OS_NAME_V_IRIX
#       if FL_OS_VERSION_V_6_5
#               if FL_OS_RELEASE_V_30


// NOTE: MIPS CPUs have a big endian architecture


#define FL_TEST_F_main_N_FILE_NOT_FOUND() \
\
	if (fl_test_env == 1)\
	{\
		if ((strcmp(fl_test_env_function_name, "main") == 0) &&\
		    (strcmp(fl_test_env_test_name, "FILE_NOT_FOUND") == 0))\
		{\
			packet.size = 34;\
			bcopy((void *) "\x00\x00\x00\x01\x00\x0c/dev/loop/f\x00\x00\x0e/tmp/testfile\x00", packet.data, packet.size);\
		}\
	}

#define FL_TEST_F_main_N_WRONG_DIR_PREFIX() \
\
        if (fl_test_env == 1)\
        {\
                if ((strcmp(fl_test_env_function_name, "main") == 0) &&\
                    (strcmp(fl_test_env_test_name, "WRONG_DIR_PREFIX") == 0))\
                {\
                        packet.size = 34;\
                        bcopy((void *) "\x00\x00\x00\x01\x00\x0c/Dev/loop/f\x00\x00\x0e/tmp/testfile\x00", packet.data, packet.size);\
                }\
        }

#define FL_TEST_F_main_N_EMPTY_BLK_DEV_NAME() \
\
        if (fl_test_env == 1)\
        {\
                if ((strcmp(fl_test_env_function_name, "main") == 0) &&\
                    (strcmp(fl_test_env_test_name, "EMPTY_BLK_DEV_NAME") == 0))\
                {\
                        packet.size = 33;\
                        bcopy((void *) "\x00\x00\x00\x01\x00\x0b/dev/loop/\x00\x00\x0e/tmp/testfile\x00", packet.data, packet.size);\
                }\
        }

#define FL_TEST_F_main_N_BLK_DEV_PATHNAME_HAS_INVALID_CHAR() \
\
        if (fl_test_env == 1)\
        {\
                if ((strcmp(fl_test_env_function_name, "main") == 0) &&\
                    (strcmp(fl_test_env_test_name, "BLK_DEV_PATHNAME_HAS_INVALID_CHAR") == 0))\
                {\
                        packet.size = 34;\
                        bcopy((void *) "\x00\x00\x00\x01\x00\x0c/dev/loop/#\x00\x00\x0e/tmp/testfile\x00", packet.data, packet.size);\
                }\
        }

#define FL_TEST_F_main_N_DEV_NAME_NOT_FOUND() \
\
        if (fl_test_env == 1)\
        {\
                if ((strcmp(fl_test_env_function_name, "main") == 0) &&\
                    (strcmp(fl_test_env_test_name, "DEV_NAME_NOT_FOUND") == 0))\
                {\
                        packet.size = 18;\
                        bcopy((void *) "\x00\x00\x00\x02\x00\x0c/dev/loop/f\x00", packet.data, packet.size);\
                }\
        }


#               endif
#       endif
#endif


#define FL_TEST_PRINTF(FORMAT_ARGS) printf FORMAT_ARGS;


void fl_test_init();
void fl_test_deinit();


#else


#define FL_TEST_INIT()
#define FL_TEST_DEINIT()


#define FL_TEST_RET


#define FL_TEST_COND(COND, OP)


#define FL_TEST_F_main_N_NOT_SUSER()
#define FL_TEST_F_main_N_ATTACH_EACCES_DEV()
#define FL_TEST_F_main_N_ATTACH_EIO_DEV()
#define FL_TEST_F_main_N_ATTACH_ELOOP_DEV()
#define FL_TEST_F_main_N_ATTACH_ENOMEM_DEV()
#define FL_TEST_F_main_N_ATTACH_ENOTDIR_DEV()
#define FL_TEST_F_main_N_ATTACH_EACCES_FILE()
#define FL_TEST_F_main_N_ATTACH_EIO_FILE()
#define FL_TEST_F_main_N_ATTACH_ELOOP_FILE()
#define FL_TEST_F_main_N_ATTACH_ENOMEM_FILE()
#define FL_TEST_F_main_N_ATTACH_ENOTDIR_FILE()
#define FL_TEST_F_main_N_DETACH_EACCES()
#define FL_TEST_F_main_N_DETACH_EIO()
#define FL_TEST_F_main_N_DETACH_ELOOP()
#define FL_TEST_F_main_N_DETACH_ENOMEM()
#define FL_TEST_F_main_N_DETACH_ENOTDIR()
#define FL_TEST_F_main_N_NOT_ALLOC_RESPONSE_PACKET()
#define FL_TEST_F_main_N_NO_PERMISSION_PACKET_DATA()
#define FL_TEST_F_main_N_NOT_PARSE_RESPONSE_PACKET()
#define FL_TEST_F_main_N_FILE_NOT_FOUND()
#define FL_TEST_F_main_N_WRONG_DIR_PREFIX()
#define FL_TEST_F_main_N_EMPTY_BLK_DEV_NAME()
#define FL_TEST_F_main_N_BLK_DEV_PATHNAME_HAS_INVALID_CHAR()
#define FL_TEST_F_main_N_DEV_NAME_NOT_FOUND()


#define FL_TEST_PRINTF(FORMAT_ARGS)


#endif


#endif


