

#ifndef __FLD_H__
#define __FLD_H__


// NOTE: OS header


#include "fld_conf_id.h"
#include "fld_common.h"


#if FLD_OS_NAME_V_OSF1
#       if FLD_OS_VERSION_V_5_1
#               if FLD_OS_RELEASE_V_B



#               endif
#       endif
#elif FLD_OS_NAME_V_IRIX
#       if FLD_OS_VERSION_V_6_5
#               if FLD_OS_RELEASE_V_30




#               endif
#       endif
#endif


enum fld_ioctl_e
{
        FLD_IOCTL_NULL        = 0x00000000,
        FLD_IOCTL_FIRST       = 0x00000100,
        FLD_IOCTL_START       = 0x00000100,
        FLD_IOCTL_START_ARGS  = 0x00000200,
        FLD_IOCTL_STOP        = 0x00000300,
        FLD_IOCTL_REQ         = 0x00000400,
        FLD_IOCTL_FIN         = 0x00000500,
        FLD_IOCTL_LAST        = 0x00000500,
        FLD_IOCTL_MASK        = 0x0000ff00
};


// NOTE: I/O control bits


enum fld_io_e
{
        FLD_IO_NULL,
        FLD_IO_READ,
        FLD_IO_READ_OK,
        FLD_IO_READ_INCMPL,
        FLD_IO_READ_EOF,
        FLD_IO_READ_NOK,
        FLD_IO_WRITE,
        FLD_IO_WRITE_OK,
        FLD_IO_WRITE_INCMPL,
        FLD_IO_WRITE_EOF,
        FLD_IO_WRITE_NOK,
        FLD_IO_MASK = 0xff
};


struct fld_io_req_s
{
        enum fld_io_e control;


        // Buf pointer (kernel virtual address)
        void *bp;


        // Offset (in bytes)
        fld_uint64_t offset;


        // Size (in bytes)
        fld_uint64_t size;


        // Device special file of attached file
        dev_t dev;


        // File name of attached file
        char file[PATH_MAX];


        // Data
        char *data;


        // Data size
        fld_uint64_t data_size;


        // Is format switch
        fld_uint32_t is_format;
};


struct fld_io_start_args_s
{
        char *io_data;

        fld_int32_t maxdmasz;
};


#endif  // __FLD_H__


