

#ifndef __FLD_COMMON_H__
#define __FLD_COMMON_H__


// NOTE: OS header


#include "fld_conf_id.h"


/******************************************************************************
 * Data type definitions (for portability)
 ******************************************************************************/

typedef unsigned char fld_uint8_t;
typedef signed char fld_int8_t;
typedef unsigned short fld_uint16_t;
typedef signed short fld_int16_t;
typedef unsigned int fld_uint32_t;
typedef signed int fld_int32_t;
typedef unsigned long long fld_uint64_t;
typedef signed long long fld_int64_t;
typedef unsigned long fld_uint3264_t;
typedef signed long fld_int3264_t;


/**************************** Public definitions ******************************/


#define FLD_LOOP_FOREVER 1


#if FLD_OS_NAME_V_OSF1
#       if FLD_OS_VERSION_V_5_1
#               if FLD_OS_RELEASE_V_B


#               endif
#       endif
#elif FLD_OS_NAME_V_IRIX
#       if FLD_OS_VERSION_V_6_5
#               if FLD_OS_RELEASE_V_30


#define FLD_UPRINTF(ARG) printf ## ARG;
#define FLD_PRINTF(ARG) printf ## ARG;


// NOTE: ESUCCESS
//
//  ESUCCESS is a macro defined in Tru64 V5.1B-3+
//  that indicates success (or absence of error)
//  and is defined in that OS's sys/errno.h header.


#define ESUCCESS 0


#               endif
#       endif
#endif


/**************************** Debug definitions *******************************/

#ifdef FLD_DEBUG


#if FLD_OS_NAME_V_OSF1
#       if FLD_OS_VERSION_V_5_1
#               if FLD_OS_RELEASE_V_B


#               endif
#       endif
#elif FLD_OS_NAME_V_IRIX
#       if FLD_OS_VERSION_V_6_5
#               if FLD_OS_RELEASE_V_30


// Forward declaration
int fld_kelog_printf(const char *,
                     ...);
#define FLD_DEBUG_UPRINTF(ARG) printf ## ARG;
#define FLD_DEBUG_PRINTF(ARG) printf ## ARG;


//#define FLD_DEBUG_UPRINTF(ARG) fld_kelog_printf ## ARG;
//#define FLD_DEBUG_PRINTF(ARG) fld_kelog_printf ## ARG;


#               endif
#       endif
#endif


#else


#define FLD_DEBUG_UPRINTF(ARG)
#define FLD_DEBUG_PRINTF(ARG)


#endif  // FLD_DEBUG


#endif  // __FLD_COMMON_H__


